//
//  ViewController.swift
//  SwiftSocket_Demo
//
//  Created by Pascal PISZYNA on 15/12/2016.
//  Copyright © 2016 Pascal PISZYNA. All rights reserved.
//

import UIKit

class ViewController: UIViewController, UITextFieldDelegate {

    var client:TCPClient?
    
    @IBOutlet weak var ipTextField: UITextField!
    @IBOutlet weak var portTextField: UITextField!
    @IBAction func connect() {
        client = TCPClient(address: ipTextField.text!,
                           port: Int32(portTextField.text!)!)
        let connexion = client?.connect(timeout: 2)
        switch connexion! {
        case .success: print ("Connexion  réussie")
        case .failure:
            print ("Erreur de connexion")
            let alert = UIAlertController(title: "Erreur de connexion",
                                          message: "Vérifiez les paramètres",
                                          preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "OK",
                                          style: .default,
                                          handler: nil))
            self.present(alert,
                         animated: true,
                         completion: nil)
        }
    }
    
    override func viewDidLoad() {
        ipTextField.delegate = self
        portTextField.delegate = self
        
        let ipSetting = UserDefaults.standard.string(forKey: "IP")
        if ipSetting != nil {
            ipTextField.text = ipSetting
        }
        else {
            ipTextField.text = "127.0.0.1"
        }

        let portSetting = UserDefaults.standard.string(forKey: "Port")
        if portSetting != nil {
            portTextField.text = portSetting
        }
        else {
            portTextField.text = "8005"
        }
}
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        UserDefaults.standard.set(ipTextField.text, forKey: "IP")
        UserDefaults.standard.set(portTextField.text, forKey: "Port")
        self.view.endEditing(true)
        return true
    }
    
    @IBAction func on() {
        sendText(msgText: "LED_ON")
    }
    
    @IBAction func off() {
        sendText(msgText: "LED_OFF")
    }
    
    func sendText(msgText : String) {
        let result = client?.send(string: (msgText + "\n"))
        switch result! {
        case .success: print ("Envoi réussi")
        case .failure: print ("Erreur d'envoi")
        }
    }
}

